unit SysFocus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TSysFocus = class(TComponent)
  private
    { Private-Deklarationen }
  protected
    { Protected-Deklarationen }
  public
    function getSysFocus:integer;
    function setSysFocus(hwnd:integer):integer;
    { Public-Deklarationen }
  published
    { Published-Deklarationen }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('My Components', [TSysFocus]);
end;

function TSysFocus.getSysFocus;
Var hOtherWin,OtherThreadID,hFocusWin:integer;
Begin
  hOtherWin := GetForegroundWindow;
  OtherThreadID := GetWindowThreadProcessID( hOtherWin, nil);
  If AttachThreadInput( GetCurrentThreadID, OtherThreadID, true ) Then
  Begin
   hFocusWin := GetFocus;
   result:=GetFocus;
    If hFocusWin <> 0 Then
    try
      //sendMessage(getFocus,wm_copy,0,0);// maybe build a multi-clipboard-viewer ?
    finally
      AttachThreadInput( GetCurrentThreadID, OtherThreadID, False );
    end;
  End
  else
   result:=getFocus;// beep;
End;

function TSysFocus.setSysFocus(hwnd:integer):integer;
Var hOtherWin,OtherThreadID,hFocusWin:integer;
Begin
  hOtherWin := GetForegroundWindow;
  OtherThreadID := GetWindowThreadProcessID( hOtherWin, nil);
  If AttachThreadInput( GetCurrentThreadID, OtherThreadID, true ) Then
  Begin
   hFocusWin := GetFocus;
   setfocus(hwnd);
   //sendMessage(hwnd,wm_setFocus,0,0);
    If hFocusWin <> 0 Then
    try
      //sendMessage(getFocus,wm_copy,0,0);//
    finally
      AttachThreadInput( GetCurrentThreadID, OtherThreadID, False );
    end;
  End
  else
   result:=setFocus(hwnd);// beep;
End;

end.
